.\"	$NetBSD: np.4,v 1.13 2003/08/07 10:31:13 agc Exp $
.\"
.\" Copyright (c) 1986, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)np.4	8.1 (Berkeley) 6/5/93
.\"
.Dd June 5, 1993
.Dt NP 4 vax
.Os
.Sh NAME
.Nm np
.Nd Interlan Np100 10 Mb/s Ethernet interface
.Sh SYNOPSIS
.Cd "np0 at uba0 csr 166000 vector npintr"
.Sh DESCRIPTION
NOTE: This driver has not been ported from
.Bx 4.4
yet.
.Pp
The
.Nm np
device provides access to an Interlan Np100 Ethernet interface
for control functions.
.Pp
This interface is unusual in that it requires loading firmware
into the controller before it may be used as a network link-level interface.
This is accomplished by opening a character special device,
and writing data to it.
It is also possible to do post-mortem debugging of firmware failures
by reading the local memory of the device.
.\" .Pp
.\" A program to load the image is provided in
.\" .Pa /usr/src/new/np100 .
.\" The sequence of commands would be:
.\" .Bd -literal -offset indent
.\" # ./npload np.image [/dev/np00]
.\" # sleep 10
.\" # ifconfig ix0 ...
.\" .Ed
.Pp
Multiple control processes are allowed by opening separate
minor devices; secondary interfaces are specified by shifting
the interface number by 4 bits.
.Pp
The device also responds to commands passed through the driver
by the following
.Xr ioctl 2 Ns s :
.Bl -tag -width NPNETBOOT
.It Dv NPRESET
kills off all active network processes.
.It Dv NPSTART
begins execution of the board at the specified address (usually
.Li 0x400 ) .
.It Dv NPNETBOOT
downloads the image from a server on the network.
[Contact
.Tn MICOM-INTERLAN
for details.]
.El
.Sh DIAGNOSTICS
.Bl -diag
.It np%d: Bad Maintenance command: %x!
An invalid
.Xr ioctl 2
was passed to the np driver.
.Pp
.It np%d: Panic NP100 bad buffer chain.
An error occurred in an read or write operation causing it to
run out of buffers before it finished the operation.
This indicates a kernel failure rather than a device failure.
.Pp
.It NP100 unit %d not found!
A failure occurred during initialization, such that the UNIBUS
address expected for the board was found to be bad.
Probably indicates hardware problems with the board, as do the following:
.Pp
.Bd -literal -offset indent -compact
NP100 Unit %d timed out!
NP100 Unit %d Failed diagnostics!
Status from CSR0: %x.
.Ed
.Pp
.It "Panic from NP100 unit %d!"
.It "Panic Message: %s."
An occurrence on the board was deemed serious enough
to have the VAX print it out.
.Pp
.It NP100 unit #%d available!
The board was successfully loaded and started.
.Pp
.It np%d: Bad Req: %x.
The board made a maintenance request to the VAX that it did not
understand.
.Pp
.It np%d: No more room on Command Queue!
The np driver allowed an internal resource to be exhausted.
This should never happen.
.El
.Pp
There are 110 other diagnostic messages that can be enabled
by setting bits in a debugging mask.
Consult the driver for details.
.Sh SEE ALSO
.Xr arp 4 ,
.Xr inet 4 ,
.Xr ix 4 ,
.Xr netintro 4
.Sh HISTORY
The
.Nm
driver appeared in
.Bx 4.3 .
